       >>SOURCE FORMAT FREE 
       program-id. xlsx.

       configuration section.
       repository.
           class j-cell as "org.apache.poi.ss.usermodel.Cell"
           class j-cellstyle as "org.apache.poi.ss.usermodel.CellStyle"
           class j-creationhelper as "org.apache.poi.ss.usermodel.CreationHelper"
           class j-row as "org.apache.poi.ss.usermodel.Row"
           class j-sheet as "org.apache.poi.ss.usermodel.Sheet"
           class j-workbook as "org.apache.poi.ss.usermodel.Workbook"
           class j-xssfworkbook as "org.apache.poi.xssf.usermodel.XSSFWorkbook"
           class j-builtinformats as "org.apache.poi.ss.usermodel.BuiltinFormats"
           class j-font as "org.apache.poi.xssf.usermodel.XSSFFont"
           class j-color as "org.apache.poi.ss.usermodel.IndexedColors"
           class j-font2 as "org.apache.poi.ss.usermodel.Font"
           class j-calendar as "java.util.Calendar"
           class j-gregorian as "java.util.GregorianCalendar"
           class j-output as "java.io.FileOutputStream"
           class j-file as "java.io.File"                     
           .

       working-storage section.
       77 w-cell object reference j-cell.
       77 w-cellstyle1 object reference j-cellstyle.
       77 w-cellstyle2 object reference j-cellstyle.
       77 w-cellstyle3 object reference j-cellstyle.
       77 w-cellstyle4 object reference j-cellstyle.
       77 w-creationhelper object reference j-creationhelper.
       77 w-row object reference j-row.
       77 w-sheet object reference j-sheet.
       77 w-workbook object reference j-workbook.
       77 w-xssfworkbook object reference j-xssfworkbook.
       77 w-builtinformats object reference j-builtinformats.
       77 w-font object reference j-font.
       77 w-font2 object reference j-font.
       77 w-color object reference j-color.
       77 w-calendar object reference j-calendar.
       77 w-calendar2 object reference j-calendar.
       77 w-output object reference j-output. 
       77 w-file object reference j-file.
       77 idx int.
       77 counter int.

       procedure division.
       main.
           try             
             set w-xssfworkbook to j-xssfworkbook:>new()
             set w-workbook to w-xssfworkbook             
             set w-sheet to w-workbook:>createSheet("sheet1")
             set w-cellstyle1 to w-workbook:>createCellStyle()
             set w-cellstyle2 to w-workbook:>createCellStyle()
             set w-cellstyle3 to w-workbook:>createCellStyle()
             w-cellstyle1:>setDataFormat(j-builtinformats:>getBuiltinFormat("m/d/yy") as short)
             w-cellstyle2:>setDataFormat(j-builtinformats:>getBuiltinFormat("d-mmm-yy") as short)
             set w-calendar to j-gregorian:>new()             
             w-calendar:>set(1990,j-calendar:>APRIL,2)
             set w-row to w-sheet:>createRow(0)
             set w-cell to w-row:>createCell(0)
             w-cell:>setCellValue(w-calendar)
             w-cell:>setCellStyle(w-cellstyle1)

      *> create the font and set the color on it applied on a particular cell      
             set w-font to w-xssfworkbook:>createFont()
             w-font:>setFontHeightInPoints(18)
             w-font:>setFontName("Comic Sans Serif")
             w-font:>setItalic(true)
             w-font:>setColor(j-color:>GREEN:>getIndex())
             w-cellstyle3:>setFont (w-font)
             set w-cell to w-row:>createCell(1)
             w-cell:>setCellValue("string1")
             w-cell:>setCellStyle(w-cellstyle3)
                          
             set w-row to w-sheet:>createRow(1)
             set w-cell to w-row:>createCell(0)
             w-cell:>setCellValue("String2")
             set w-cell to w-row:>createCell(1)

      *> highlight all the cell of the second row                    
             set w-cellstyle4 to w-workbook:>createCellStyle()
             set w-font2 to w-xssfworkbook:>createFont()
             w-font2:>setFontHeightInPoints(18)
             w-font2:>setFontName("Courier New")
             w-font2:>setBold(true)
             w-font2:>setColor(j-color:>RED:>getIndex())

             w-cellstyle4:>setFont(w-font2)
             set idx to w-row:>getLastCellNum()
             perform varying counter from 0 by 1 until counter = idx
                w-row:>getCell(counter):>setCellStyle(w-cellstyle4)
             end-perform   
                          
             w-cell:>setCellValue(w-calendar)
             w-cellstyle2:>setFont(w-font)
             w-cell:>setCellStyle(w-cellstyle2)
                                                                 
             set w-output to j-output:>new(j-file:>new("excel-file.xlsx"))
             w-workbook:>write(w-output)
             w-output:>close()
             display "Program terminated"
           catch exception
             display message exception-object:>getMessage()
           end-try.
           stop run.
          
